//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>
#include <stdlib.h>

int main( int argc, char *argv[] )
{
    struct
    {
        __declspec(align(16)) float src[4];
        __declspec(align(16)) float dst[4];
    } d ;
    int i;

    if( argc != 5 )
    {
        fprintf(stderr, "usage: pgm [arg1] [arg2] [arg3] [arg4]\n");
        return -1;
    }

    for(i=0;i<4;i++)
        d.src[i] = (float)atof(argv[4-i]);

    __asm
    {
        movaps      xmm0,  d.src
        movaps      xmm1,  xmm0
        movaps      d.dst, xmm1
    }

    printf("     source: %12.4f, %12.4f, %12.4f, %12.4f\n",
                            d.src[3], d.src[2], d.src[1], d.src[0]);
    printf("     result: %12.4f, %12.4f, %12.4f, %12.4f\n",
                            d.dst[3], d.dst[2], d.dst[1], d.dst[0]);

    return 0;
}