//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
//
#include <stdio.h>
#include <stdlib.h>

int main( int argc, char *argv[] )
{
    __declspec(align(8)) float src[2];
    __declspec(align(8)) float dst[2];
    __declspec(align(16)) float tmp[4];

    if( argc != 3 )
    {
        fprintf(stderr, "usage: pgm [arg1] [arg2]\n");
        return -1;
    }

    src[1] = (float)atof(argv[1]);
    src[0] = (float)atof(argv[2]);

    __asm
    {
        xorps       xmm0,  xmm0
        movlps      xmm0,  src
        movaps      tmp,   xmm0
        movlps      dst,   xmm0
    }

    printf("     source   : %12.4f, %12.4f\n", src[1], src[0]);
    printf("     temporal : %12.4f, %12.4f, %12.4f, %12.4f\n",
                                    tmp[3], tmp[2], tmp[1], tmp[0]);
    printf("     result   : %12.4f, %12.4f\n", dst[1], dst[0]);

    return 0;
}