//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
//
#include <stdio.h>
#include <stdlib.h>

int main( int argc, char *argv[] )
{
    double tmp[2], src, dst;

    if( argc != 2 )
    {
        fprintf(stderr, "usage: pgm [arg1]\n");
        return -1;
    }

    src = strtod(argv[1],NULL);

    __asm
    {
        xorps     xmm0, xmm0
        movsd     xmm0, src
        movsd     xmm1, xmm0
        movups    tmp,  xmm0
        movsd     dst,  xmm1
    }

    printf("     source   : %12.4f\n", src );
    printf("     temporal : %12.4f, %12.4f\n", tmp[1], tmp[0]);
    printf("     result   : %12.4f\n", dst );

    return 0;
}