// movd_mmx.c
//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>
#include <stdlib.h>

int main( int argc, char *argv[] )
{
    double src[2];
    double dst;

    if( argc != 3 )
    {
        fprintf(stderr, "usage: pgm [arg1] [arg2]\n");
        return -1;
    }

    src[1] = strtod(argv[1],NULL);
    src[0] = strtod(argv[2],NULL);

    __asm
    {
        movdqu      xmm0, src
        movdq2q     mm0,  xmm0
        movq        dst,  mm0

        emms
    }

    printf("     source : %12.4f, %12.4f\n", src[1], src[0]);
    printf("     result : %12.4f\n", dst);

    return 0;
}