//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>
#include <stdlib.h>

int main( int argc, char *argv[] )
{
    double src[2],ans[2];

    if( argc != 3 )
    {
        fprintf(stderr, "usage: pgm [arg1] [arg2]\n");
        return -1;
    }

    src[0] = strtod(argv[2], NULL);
    src[1] = strtod(argv[1], NULL);

    __asm
    {
        movups     xmm0, src
        movddup    xmm1, xmm0
        movups     ans,  xmm1
    }

    printf("     source: (%12.4f, %12.4f)\n", src[1], src[0]);
    printf("     result: (%12.4f, %12.4f)\n", ans[1], ans[0]);

    return 0;
}