//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>
#include <stdlib.h>

int main( int argc, char *argv[] )
{
    short src[4],dst[4],ans[4];
    int i;

    if( argc != 9 )
    {
        fprintf(stderr, "usage: pgm [arg1] [arg2] [arg3] [arg4] "
                                    "[arg5] [arg6] [arg7] [arg8]\n");
        return -1;
    }

    for(i=0;i<sizeof(src)/sizeof(src[0]);i++)
    {
        src[i] = (short)atoi(argv[4-i]);
        dst[i] = (short)atoi(argv[8-i]);
    }

    __asm
    {
        movq    mm1, dst
        pmaxsw  mm1, src
        movq    ans, mm1

        emms
    }

    printf("     source: (%5d,%5d,%5d,%5d)\n",src[3],src[2],src[1],src[0]);
    printf("destination: (%5d,%5d,%5d,%5d)\n",dst[3],dst[2],dst[1],dst[0]);
    printf("     result: (%5d,%5d,%5d,%5d)\n",ans[3],ans[2],ans[1],ans[0]);

    return 0;
}