//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>
#include <stdlib.h>

int main( int argc, char *argv[] )
{
    short src[8],dst[8],ans[8];
    int i;

    if( argc != 17 )
    {
        fprintf(stderr, "usage: pgm [arg01] [arg02] [arg03] [arg04] "
                                   "[arg05] [arg06] [arg07] [arg08]\n"
                        "           [arg09] [arg10] [arg11] [arg12] "
                                   "[arg13] [arg14] [arg15] [arg16]\n");
        return -1;
    }

    for(i=0;i<sizeof(src)/sizeof(src[0]);i++)
    {
        src[i] = (short)atoi(argv[8-i]);
        dst[i] = (short)atoi(argv[16-i]);
    }

    __asm
    {
        movdqu  xmm0, src
        movdqu  xmm1, dst
        pminsw  xmm1, xmm0
        movdqu  ans,  xmm1
    }

    printf("     source: (%5d,%5d,%5d,%5d,%5d,%5d,%5d,%5d)\n",
        src[7],src[6],src[5],src[4],src[3],src[2],src[1],src[0]);
    printf("destination: (%5d,%5d,%5d,%5d,%5d,%5d,%5d,%5d)\n",
        dst[7],dst[6],dst[5],dst[4],dst[3],dst[2],dst[1],dst[0]);
    printf("     result: (%5d,%5d,%5d,%5d,%5d,%5d,%5d,%5d)\n",
        ans[7],ans[6],ans[5],ans[4],ans[3],ans[2],ans[1],ans[0]);

    return 0;
}