//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>
#include <stdlib.h>

int main( int argc, char *argv[] )
{
    unsigned short src[4],dst[4],ans[4];
    int i;

    if( argc != 9 )
    {
        fprintf(stderr, "usage: pgm [arg1] [arg2] [arg3] [arg4] "
                                    "[arg5] [arg6] [arg7] [arg8]\n");
        return -1;
    }

    for(i=0;i<sizeof(src)/sizeof(src[0]);i++)
    {
        src[i] = (unsigned short)atoi(argv[i+1]);
        dst[i] = (unsigned short)atoi(argv[i+5]);
    }

    __asm
    {
        movq     mm0, dst
        pmulhuw  mm0, src
        movq     ans, mm0

        emms
    }

    for(i=0;i<sizeof(src)/sizeof(src[0]);i++)
        printf("  %6d * %6d = %6d (0x%04X)\n",src[i],dst[i],ans[i],ans[i]);

    return 0;
}