//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>
#include <stdlib.h>

int main( int argc, char *argv[] )
{
    double src[2], dst[2], ans[2];

    if( argc != 5 )
    {
        fprintf(stderr, "usage: pgm [arg1] [arg2] [arg3] [arg4]\n");
        return -1;
    }

    src[1] = strtod(argv[1],NULL);
    src[0] = strtod(argv[2],NULL);
    dst[1] = strtod(argv[3],NULL);
    dst[0] = strtod(argv[4],NULL);

    __asm
    {
        movdqu  xmm0, src
        movdqu  xmm1, dst
        divsd   xmm1, xmm0
        movdqu  ans,  xmm1
    }

    printf("     source: (%12.4f, %12.4f)\n",src[1],src[0]);
    printf("destination: (%12.4f, %12.4f)\n",dst[1],dst[0]);
    printf("     result: (%12.4f, %12.4f)\n",ans[1],ans[0]);

    return 0;
}
