//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>
#include <stdlib.h>

int main( int argc, char *argv[] )
{
    unsigned int src[2], dst[2], ans[2];

    if( argc != 3 )
    {
        fprintf(stderr, "usage: pgm [arg1] [arg2]\n");
        return -1;
    }

    src[1] = 0;
    src[0] = atoi(argv[1]);
    dst[1] = 0;
    dst[0] = atoi(argv[2]);

    __asm
    {
        movq     mm0, dst
        pmuludq  mm0, src
        movq     ans, mm0

        emms
    }

    printf(" %d * %d = %08X%08X\n",src[0],dst[0],ans[1],ans[0]);

    return 0;
}
