//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>

int main( int argc, char *argv[] )
{
    float src[4] = {4.0f,4.0f,4.0f,4.0f};
    float dst[4] = {6.0f,5.0f,4.0f,3.0f};
    unsigned int ans[4];

    __asm
    {
        movdqu   xmm0, src
        movdqu   xmm1, dst
        cmpss    xmm1, xmm0, 0
        movdqu   ans,  xmm1
    }

    printf("imm8 = 0(EQ)\n");
    printf("     source: (%4.4f, %4.4f, %4.4f, %4.4f)\n",src[3],src[2],src[1],src[0]);
    printf("destination: (%4.4f, %4.4f, %4.4f, %4.4f)\n",dst[3],dst[2],dst[1],dst[0]);
    printf("     result: %08X,%08X,%08X,%08X\n",ans[3],ans[2],ans[1],ans[0]);


    __asm
    {
        movdqu   xmm0, src
        movdqu   xmm1, dst
        cmpss    xmm1, xmm0, 1
        movdqu   ans,  xmm1
    }

    printf("imm8 = 1(LT)\n");
    printf("     source: (%4.4f, %4.4f, %4.4f, %4.4f)\n",src[3],src[2],src[1],src[0]);
    printf("destination: (%4.4f, %4.4f, %4.4f, %4.4f)\n",dst[3],dst[2],dst[1],dst[0]);
    printf("     result: %08X,%08X,%08X,%08X\n",ans[3],ans[2],ans[1],ans[0]);


    __asm
    {
        movdqu   xmm0, src
        movdqu   xmm1, dst
        cmpss    xmm1, xmm0, 6
        movdqu   ans,  xmm1
    }

    printf("imm8 = 6(NLE)\n");
    printf("     source: (%4.4f, %4.4f, %4.4f, %4.4f)\n",src[3],src[2],src[1],src[0]);
    printf("destination: (%4.4f, %4.4f, %4.4f, %4.4f)\n",dst[3],dst[2],dst[1],dst[0]);
    printf("     result: %08X,%08X,%08X,%08X\n",ans[3],ans[2],ans[1],ans[0]);

    return 0;
}