//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>

int main( int argc, char *argv[] )
{
    double src[2] = {4.0f,4.0f};
    double dst[2] = {5.0f,4.0f};
    unsigned int ans[4];

    __asm
    {
        movdqu   xmm0, src
        movdqu   xmm1, dst
        cmpsd    xmm1, xmm0, 0
        movdqu   ans,  xmm1
    }

    printf("imm8 = 0(EQ)\n");
    printf("     source: (%4.13f,%4.13f)\n",src[1],src[0]);
    printf("destination: (%4.13f,%4.13f)\n",dst[1],dst[0]);
    printf("     result: %08X%08X,%08X%08X\n",ans[3],ans[2],ans[1],ans[0]);


    __asm
    {
        movdqu   xmm0, src
        movdqu   xmm1, dst
        cmpsd    xmm1, xmm0, 1
        movdqu   ans,  xmm1
    }

    printf("imm8 = 1(LT)\n");
    printf("     source: (%4.13f,%4.13f)\n",src[1],src[0]);
    printf("destination: (%4.13f,%4.13f)\n",dst[1],dst[0]);
    printf("     result: %08X%08X,%08X%08X\n",ans[3],ans[2],ans[1],ans[0]);


    __asm
    {
        movdqu   xmm0, src
        movdqu   xmm1, dst
        cmpsd    xmm1, xmm0, 6
        movdqu   ans,  xmm1
    }

    printf("imm8 = 6(NLE)\n");
    printf("     source: (%4.13f,%4.13f)\n",src[1],src[0]);
    printf("destination: (%4.13f,%4.13f)\n",dst[1],dst[0]);
    printf("     result: %08X%08X,%08X%08X\n",ans[3],ans[2],ans[1],ans[0]);

    return 0;
}