//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
//
// __mmɏĂ悵
//
#include <stdio.h>
#include <stdlib.h>

int main( int argc, char *argv[] )
{
    __declspec(align(8))  float src[2];
    __declspec(align(8))  float dst1[2];
    __declspec(align(16)) float dst2[4];

    if( argc != 3 )
    {
        fprintf(stderr, "usage: pgm [arg1] [arg2]\n");
        return -1;
    }

    src[1] = (float)atof(argv[1]);
    src[0] = (float)atof(argv[2]);

    __asm
    {
        xorps       xmm0,  xmm0
        movhps      xmm0,  src
        movaps      dst2,  xmm0
        movhps      dst1,  xmm0
    }

    printf("     source : %12.4f, %12.4f\n", src[1], src[0]);
    printf("     result : %12.4f, %12.4f, %12.4f, %12.4f\n",
                                dst2[3], dst2[2], dst2[1], dst2[0]);
    printf("     result : %12.4f, %12.4f\n", dst1[1], dst1[0]);

    return 0;
}