//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
//
#include <stdio.h>
#include <stdlib.h>

int main( int argc, char *argv[] )
{
    float tmp[4], src, dst;

    if( argc != 2 )
    {
        fprintf(stderr, "usage: pgm [arg1]\n");
        return -1;
    }

    src = (float)atof(argv[1]);

    __asm
    {
		xorps	  xmm1, xmm1
        movss     xmm0, src
        movss     xmm1, xmm0
        movups    tmp,  xmm0
        movss     dst,  xmm1
    }

    printf("     source   : %12.4f\n", src );
    printf("     temporal : %12.4f, %12.4f, %12.4f, %12.4f\n",
                                        tmp[3], tmp[2], tmp[1], tmp[0]);
    printf("     result   : %12.4f\n", dst );

    return 0;
}