//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>
#include <stdlib.h>

int main( int argc, char *argv[] )
{
    __declspec(align(16)) double src[2];
    __declspec(align(16)) double dst[2];

    if( argc != 3 )
    {
        fprintf(stderr, "usage: pgm [arg1] [arg2]\n");
        return -1;
    }

    src[1] = strtod(argv[1],NULL);
    src[0] = strtod(argv[2],NULL);

    __asm
    {
        movapd      xmm0, src
        movapd      xmm1, xmm0
        movapd      dst,  xmm1
    }

    printf("     source: %12.4f, %12.4f\n", src[1], src[0]);
    printf("     result: %12.4f, %12.4f\n", dst[1], dst[0]);

    return 0;
}