//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>
#include <stdlib.h>

int main( int argc, char *argv[] )
{
    #pragma pack(push, 1)
    struct
    {
        char   c;
        double src[2];
        double dst[2];
    } a1 ;
    #pragma pack(pop)

    if( argc != 3 )
    {
        fprintf(stderr, "usage: pgm [arg1] [arg2]\n");
        return -1;
    }

    a1.src[1] = strtod(argv[1],NULL);
    a1.src[0] = strtod(argv[2],NULL);

    __asm
    {
        movupd      xmm0,   a1.src
        movupd      xmm1,   xmm0
        movupd      a1.dst, xmm1
    }

    printf("     source: %12.4f, %12.4f\n", a1.src[1], a1.src[0]);
    printf("     result: %12.4f, %12.4f\n", a1.dst[1], a1.dst[0]);

    return 0;
}