//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
//
#include <stdio.h>
#include <stdlib.h>

int main( int argc, char *argv[] )
{
    __declspec(align(8)) double src;
    __declspec(align(8)) double dst;
    double tmp[2];

    if( argc != 2 )
    {
        fprintf(stderr, "usage: pgm [arg1]\n");
        return -1;
    }

    src = (float)atof(argv[1]);

    __asm
    {
        xorps       xmm0, xmm0
        movlpd      xmm0, src
        movupd      tmp,  xmm0
        movlpd      dst,  xmm0
    }

    printf("     source   : %12.4f\n", src );
    printf("     temporal : %12.4f, %12.4f\n", tmp[1], tmp[0]);
    printf("     result   : %12.4f\n", dst );

    return 0;
}