//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
//
#include <stdio.h>
#include <stdlib.h>

int main( int argc, char *argv[] )
{
    double src[2];
    int    dst;

    if( argc != 3 )
    {
        fprintf(stderr, "usage: pgm [arg1] [arg2]\n");
        return -1;
    }

    src[1] = strtod(argv[1],NULL);
    src[0] = strtod(argv[2],NULL);

    __asm
    {
        movupd      xmm0, src
        movmskpd    eax,  xmm0
        mov         dst,  eax
    }

    printf("     source : %12.4f, %12.4f\n", src[1], src[0]);
    printf("     result : %04X\n", dst );

    return 0;
}