//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>
#include <stdlib.h>

int main( int argc, char *argv[] )
{
    #pragma pack(push, 1)
    struct
    {
        char         c;
        unsigned int src[4];
        unsigned int dst[4];
    } a1 ;
    #pragma pack(pop)

    a1.src[3]=0x01234567;
    a1.src[2]=0x89abcdef;
    a1.src[1]=0xfedcba98;
    a1.src[0]=0x76543210;

    __asm
    {
        movdqu      xmm0,   a1.src
        movdqu      xmm1,   xmm0
        movdqu      a1.dst, xmm1
    }

    printf("     source: %08X %08X %08X %08X\n",
                            a1.src[3], a1.src[2], a1.src[1], a1.src[0]);
    printf("     result: %08X %08X %08X %08X\n",
                            a1.dst[3], a1.dst[2], a1.dst[1], a1.dst[0]);

    return 0;
}