// movd_mmx.c
//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>
#include <stdlib.h>

int main( int argc, char *argv[] )
{
    double src;
    double dst[2];

    if( argc != 2 )
    {
        fprintf(stderr, "usage: pgm [arg1]\n");
        return -1;
    }

    src = strtod(argv[1],NULL);

    __asm
    {
        movq        mm0,  src
        movq2dq     xmm0, mm0
        movupd      dst,  xmm0

        emms
    }

    printf("     source : %12.4f\n", src );
    printf("     result : %12.4f, %12.4f\n", dst[1], dst[0]);

    return 0;
}