//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>
#include <stdlib.h>

int main( int argc, char *argv[] )
{
    float src[4],ans[4];
    int i;

    if( argc != 5 )
    {
        fprintf(stderr, "usage: pgm [arg1] [arg2] [arg3] [arg4]\n");
        return -1;
    }

    for(i=0;i<4;i++)
    {
        src[i] = (float)atof(argv[4-i]);
    }

    __asm
    {
        movups      xmm0, src
        movsldup    xmm1, xmm0
        movups      ans,  xmm1
    }

    printf("     source: (%12.4f, %12.4f, %12.4f, %12.4f)\n",
                                src[3], src[2], src[1], src[0]);
    printf("     result: (%12.4f, %12.4f, %12.4f, %12.4f)\n",
                                ans[3], ans[2], ans[1], ans[0]);

    return 0;
}