//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
//
#include <stdio.h>
#include <stdlib.h>

int main( int argc, char *argv[] )
{
    char src[8];
    int  ans, i;

    if( argc != 9 )
    {
        fprintf(stderr, "usage: pgm [arg1] [arg2] [arg3] [arg4] "
                                    "[arg5] [arg6] [arg7] [arg8]\n");
        return -1;
    }

    for(i=0;i<sizeof(src)/sizeof(src[0]);i++)
        src[i] = (char)atoi(argv[8-i]);

    __asm
    {
        movq      mm0, src
        pmovmskb  eax, mm0
        mov       ans, eax

        emms
    }

    printf("  source : %4d,%4d,%4d,%4d,%4d,%4d,%4d,%4d\n",
            src[7],src[6],src[5],src[4],src[3],src[2],src[1],src[0]);
    printf("  result : %08X\n", ans );

    return 0;
}