//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
//
#include <stdio.h>
#include <stdlib.h>

int main( int argc, char *argv[] )
{
    char src[16];
    int  ans, i;

    if( argc != 17 )
    {
        fprintf(stderr, "usage: pgm [arg01] [arg02] [arg03] [arg04] "
                                   "[arg05] [arg06] [arg07] [arg08]\n"
                        "           [arg09] [arg10] [arg11] [arg12] "
                                   "[arg13] [arg14] [arg15] [arg16]\n");
        return -1;
    }

    for(i=0;i<sizeof(src)/sizeof(src[0]);i++)
        src[i] = (char)atoi(argv[16-i]);

    __asm
    {
        movdqu    xmm0, src
        pmovmskb  eax, xmm0
        mov       ans, eax
    }

    printf("  source : %4d,%4d,%4d,%4d,%4d,%4d,%4d,%4d%4d,"
                                "%4d,%4d,%4d,%4d,%4d,%4d,%4d\n",
            src[15],src[14],src[13],src[12],src[11],src[10],src[9],src[8],
                    src[7],src[6],src[5],src[4],src[3],src[2],src[1],src[0]);
    printf("  result : %08X\n", ans );

    return 0;
}