//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>
#include <stdlib.h>

int main( int argc, char *argv[] )
{
    unsigned short src[8],dst[8],ans[8];
    int i;

    if( argc != 17 )
    {
        fprintf(stderr, "usage: pgm [arg01] [arg02] [arg03] [arg04] "
                                   "[arg05] [arg06] [arg07] [arg08]\n"
                        "           [arg09] [arg10] [arg11] [arg12] "
                                   "[arg13] [arg14] [arg15] [arg16]\n");
        return -1;
    }

    for(i=0;i<sizeof(src)/sizeof(src[0]);i++)
    {
        src[i] = (unsigned short)atoi(argv[i+1]);
        dst[i] = (unsigned short)atoi(argv[i+9]);
    }


    __asm
    {
        movdqu  xmm0, src
        movdqu  xmm1, dst
        pmulhuw xmm0, xmm1
        movdqu  ans,  xmm0
    }

    for(i=0;i<sizeof(src)/sizeof(src[0]);i++)
        printf( "  %6d * %6d = %6d (0x%04X)\n",
                src[i], dst[i], ans[i], (unsigned short)ans[i] ) ;

    return 0;
}