//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>
#include <stdlib.h>

int main( int argc, char *argv[] )
{
    float src[4], dst[4], ans[4];

    if( argc != 9 )
    {
        fprintf(stderr, "usage: pgm [arg1] [arg2] [arg3] [arg4]"
                                    " [arg5] [arg6] [arg7] [arg8]\n");
        return -1;
    }

    src[3] = (float)atof(argv[1]);
    src[2] = (float)atof(argv[2]);
    src[1] = (float)atof(argv[3]);
    src[0] = (float)atof(argv[4]);
    dst[3] = (float)atof(argv[5]);
    dst[2] = (float)atof(argv[6]);
    dst[1] = (float)atof(argv[7]);
    dst[0] = (float)atof(argv[8]);

    __asm
    {
        movdqu    xmm0, src
        movdqu    xmm1, dst
        addsubps  xmm1, xmm0
        movdqu    ans,  xmm1
    }

    printf("     source: (%12.4f, %12.4f, %12.4f, %12.4f)\n",
                                        src[3],src[2],src[1],src[0]);
    printf("destination: (%12.4f, %12.4f, %12.4f, %12.4f)\n",
                                        dst[3],dst[2],dst[1],dst[0]);
    printf("     result: (%12.4f, %12.4f, %12.4f, %12.4f)\n",
                                        ans[3],ans[2],ans[1],ans[0]);

    return 0;
}
