//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>
#include <stdlib.h>

int main( int argc, char *argv[] )
{
    unsigned int src[4], dst[4], ans[4];

    if( argc != 5 )
    {
        fprintf(stderr, "usage: pgm [arg1] [arg2] [arg3] [arg4]\n");
        return -1;
    }

    src[0] = atoi(argv[1]);
    src[1] = 0;
    src[2] = atoi(argv[2]);
    src[3] = 0;
    dst[0] = atoi(argv[3]);
    dst[1] = 0;
	dst[2] = atoi(argv[4]);
    dst[3] = 0;

    __asm
    {
        movdqu  xmm0, src
        movdqu  xmm1, dst
        pmuludq xmm1, xmm0
        movdqu  ans,  xmm1
    }

    printf(" %d * %d = %08X%08X\n",src[0],dst[0],ans[1],ans[0]);
    printf(" %d * %d = %08X%08X\n",src[2],dst[2],ans[3],ans[2]);

    return 0;
}