//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>

int main( int argc, char *argv[] )
{
    unsigned char src[16] = {0x80,0x01,0x80,0x01,0x80,0x01,0x80,0x01,
                                0x80,0x01,0x80,0x01,0x80,0x01,0x80,0x01};
    unsigned char dst[16] = {0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
                                0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01};
    unsigned char ans[16];
    int i;

    __asm
    {
        movdqu   xmm0, src
        movdqu   xmm1, dst
        pcmpeqb  xmm1, xmm0
        movdqu   ans,  xmm1
    }

    printf("     source: ");
    for(i=0;i<15;i++) printf("%02X",src[i]);
    printf("%02X\n",src[15]);

    printf("destination: ");
    for(i=0;i<15;i++) printf("%02X",dst[i]);
    printf("%02X\n",dst[15]);

    printf("     result: ");
    for(i=0;i<15;i++)
        printf("%02X",ans[i]);
    printf("%02X\n",ans[15]);

    return 0;
}