//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>

int main( int argc, char *argv[] )
{
    unsigned char src[8] = {0x80,0x01,0x80,0x01,0x80,0x01,0x80,0x01};
    unsigned char dst[8] = {0x80,0x01,0x00,0x80,0x01,0x00,0x80,0x01};
    unsigned char ans[8];

    __asm
    {
        movq     mm0, src
        movq     mm1, dst
        pcmpgtb  mm1, mm0
        movq     ans, mm1

        emms
    }

    printf("     source: %02X%02X%02X%02X%02X%02X%02X%02X\n",
                src[0],src[1],src[2],src[3],src[4],src[5],src[6],src[7]);
    printf("destination: %02X%02X%02X%02X%02X%02X%02X%02X\n",
                dst[0],dst[1],dst[2],dst[3],dst[4],dst[5],dst[6],dst[7]);
    printf("     result: %02X%02X%02X%02X%02X%02X%02X%02X\n",
                ans[0],ans[1],ans[2],ans[3],ans[4],ans[5],ans[6],ans[7]);

    return 0;
}