//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>
#include <stdlib.h>

int main( int argc, char *argv[] )
{
    float src[4],dst[4];
    int   ans, i;

    if( argc != 9 )
    {
        fprintf(stderr, "usage: pgm [arg1] [arg2] [arg3] [arg4] "
                                    "[arg5] [arg6] [arg7] [arg8]\n");
        return -1;
    }

    for(i=0;i<4;i++)
    {
        src[i] = (float)atof(argv[4-i]);
        dst[i] = (float)atof(argv[8-i]);
    }

    __asm
    {
        mov     eax, 0

        movdqu  xmm0, src
        movdqu  xmm1, dst
        comiss  xmm1, xmm0
        jne     not_equ
        jc      not_equ

        mov     eax, 1
        not_equ:

        mov      ans, eax
    }

    printf("     source: (%2.8f, %2.8f, %2.8f, %2.8f)\n",
                                src[3], src[2], src[1], src[0]);
    printf("destination: (%2.8f, %2.8f, %2.8f, %2.8f)\n",
                                dst[3], dst[2], dst[1], dst[0]);
    if( ans )
        printf("%2.8f == %2.8f\n",src[0], dst[0]);
    else
        printf("%2.8f != %2.8f\n",src[0], dst[0]);

    return 0;
}